package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.cecep.talroad.vo.query.OdsOnlineOlPortinfoAQuery;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.security.InvalidParameterException;
import java.util.List;
import java.util.Arrays;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;

import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.domain.OdsOnlineOlPortinfoA;
import cn.cecep.talroad.vo.OdsOnlineOlPortinfoAVo;
import cn.cecep.talroad.service.IOdsOnlineOlPortinfoAService;


/**
 * * 开发公司：中节能天融科技有限公司
 * 点位信息Controller 控制层
 *
 * @author szhpt
 * @date 2023-06-10*/
@Api(tags = "点位信息")
@RestController
@RequestMapping("/onlinePortInfo")
public class OdsOnlineOlPortinfoAController extends BasesController
{
    @Autowired
    private IOdsOnlineOlPortinfoAService odsOnlineOlPortinfoAService;

    /**
     * 查询点位信息列表
     */
    @ApiOperation(value = "查询点位信息")
    @GetMapping("/list")
    public AjaxResults<IPage<OdsOnlineOlPortinfoA>> list(OdsOnlineOlPortinfoAQuery odsOnlineOlPortinfoA)
    {
        Page<OdsOnlineOlPortinfoA> page = new Page<>(odsOnlineOlPortinfoA.getPageNum(), odsOnlineOlPortinfoA.getPageSize());
        IPage<OdsOnlineOlPortinfoA> list = odsOnlineOlPortinfoAService.page(page, OdsOnlineOlPortinfoAQuery.createLambdaQueryWrapper(odsOnlineOlPortinfoA));
        return AjaxResults.success(list);
    }


    /**
     * 导出点位信息列表
     */
    @ApiOperation(value = "导出点位信息")
    @Log(title = "点位信息", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, OdsOnlineOlPortinfoA odsOnlineOlPortinfoA)
    {
        List<OdsOnlineOlPortinfoA> list = odsOnlineOlPortinfoAService.selectOdsOnlineOlPortinfoAList(odsOnlineOlPortinfoA);
        ExcelUtil<OdsOnlineOlPortinfoA> util = new ExcelUtil<OdsOnlineOlPortinfoA>(OdsOnlineOlPortinfoA.class);
        util.exportExcel(response, list, "点位信息数据");
    }

    /**
     * 获取点位信息详细信息
     */
    @ApiOperation(value = "获取点位信息详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<OdsOnlineOlPortinfoA> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(odsOnlineOlPortinfoAService.getById(id));
    }
    /**
     * 新增点位信息
     */
    @ApiOperation(value = "新增点位信息")
    @Log(title = "点位信息", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody OdsOnlineOlPortinfoA odsOnlineOlPortinfoA) {
        return toAjax(odsOnlineOlPortinfoAService.save(odsOnlineOlPortinfoA));
    }
    /**
     * 修改点位信息
     */
    @ApiOperation(value = "修改点位信息")
    @Log(title = "点位信息", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody OdsOnlineOlPortinfoAVo odsOnlineOlPortinfoAVo) {
        if(ObjectUtil.isEmpty(odsOnlineOlPortinfoAVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(odsOnlineOlPortinfoAVo.getId())){
            throw new InvalidParameterException("参数id为空");
        }
        OdsOnlineOlPortinfoA odsOnlineOlPortinfoA = odsOnlineOlPortinfoAService.getById(odsOnlineOlPortinfoAVo.getId());
        if(ObjectUtil.isEmpty(odsOnlineOlPortinfoA)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", odsOnlineOlPortinfoAVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(odsOnlineOlPortinfoAVo,odsOnlineOlPortinfoA);
        return toAjax(odsOnlineOlPortinfoAService.saveOrUpdate(odsOnlineOlPortinfoA));
    }

    /**
     * 删除点位信息
     */
    @ApiOperation(value = "删除点位信息")
    @RequiresPermissions("talroad:a:remove")
    @Log(title = "点位信息", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(odsOnlineOlPortinfoAService.removeByIds(Arrays.asList(ids)));
    }
}
